ON_Leader2 Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_annotation2.h>`

Inheritance diagram for ON_Leader2:

## Public Types

enum | POINT_INDEX { arrow_pt_index = 0, text_pivot_pt = 10000, tail_pt = 10001 }
Public Types inherited from ON_Annotation2

enum

eTextJustification {
tjUndefined = 0, tjLeft = 1<<0, tjCenter = 1<<1, tjRight = 1<<2,
tjBottom = 1<<16, tjMiddle = 1<<17, tjTop = 1<<18, tjBottomLeft = tjBottom | tjLeft,
tjBottomCenter = tjBottom | tjCenter, tjBottomRight = tjBottom | tjRight, tjMiddleLeft = tjMiddle | tjLeft, tjMiddleCenter = tjMiddle | tjCenter,
tjMiddleRight = tjMiddle | tjRight, tjTopLeft = tjTop | tjLeft, tjTopCenter = tjTop | tjCenter, tjTopRight = tjTop | tjRight
}

## Public Member Functions

| ON_Leader2 ()
| ~ON_Leader2 ()
ON_BOOL32 | Transform (const ON_Xform &xform)
ON_2dPoint | Dim2dPoint (int point_index) const
ON_3dPoint | Dim3dPoint (int point_index) const
ON_BOOL32 | IsValid (ON_TextLog *text_log=0) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
void | AddPoint (const ON_2dPoint &point)
bool | RemovePoint (int index=-1)
void | GetV2Form (ON_Leader &leader)
bool | CreateFromV2 (const ON_Annotation &v2_ann, const ON_3dmAnnotationSettings &settings, int dimstyle_index)
bool | GetTextDirection (ON_2dVector &text_dir) const
bool | GetArrowHeadDirection (ON_2dVector &arrowhead_dir) const
bool | GetArrowHeadTip (ON_2dPoint &arrowhead_tip) const
Public Member Functions inherited from ON_Annotation2
| ON_Annotation2 ()
| ~ON_Annotation2 ()
| ON_Annotation2 (const ON_Annotation &)
ON_Annotation2 & | operator= (const ON_Annotation &)
void | Create ()
void | Destroy ()
void | EmergencyDestroy ()
ON::object_type | ObjectType () const
int | Dimension () const
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
bool | IsText () const
bool | IsLeader () const
bool | IsDimension () const
int | Index () const
void | SetIndex (int)
virtual double | NumericValue () const
void | SetHeight (double)
double | Height () const
void | SetType (ON::eAnnotationType)
ON::eAnnotationType | Type () const
void | SetPlane (const ON_Plane &)
const ON_Plane & | Plane () const
int | PointCount () const
void | SetPointCount (int count)
void | SetPoints (const ON_2dPointArray &)
const ON_2dPointArray & | Points () const
void | SetPoint (int, const ON_2dPoint &)
ON_2dPoint | Point (int) const
ON_DEPRECATED void | SetUserText (const wchar_t *text_value)
ON_DEPRECATED const ON_wString & | UserText () const
const wchar_t * | TextValue () const
void | SetTextValue (const wchar_t *text_value)
const wchar_t * | TextFormula () const
void | SetTextFormula (const wchar_t *s)
void | SetUserPositionedText (int bUserPositionedText)
bool | UserPositionedText () const
void | SetTextDisplayMode (ON::eTextDisplayMode)
ON::eTextDisplayMode | TextDisplayMode () const
ON_BOOL32 | GetECStoWCSXform (ON_Xform &) const
ON_BOOL32 | GetWCStoECSXform (ON_Xform &xform) const
void | ReservePoints (int)
virtual void | ConvertBack (ON_Annotation &target)
virtual void | SetJustification (unsigned int justification)
virtual unsigned int | Justification ()
bool | GetTextXform (ON_RECT gdi_text_rect, int gdi_height_of_I, double dimstyle_textheight, double dimstyle_textgap, ON::eTextDisplayMode dimstyle_textalignment, double dimscale, ON_3dVector cameraX, ON_3dVector cameraY, const ON_Xform *model_xform, ON_Xform &text_xform) const
bool | GetTextXform (ON_RECT gdi_text_rect, int gdi_height_of_I, double dimstyle_textheight, double dimstyle_textgap, ON::eTextDisplayMode dimstyle_textalignment, double dimscale, ON_3dVector cameraX, ON_3dVector cameraY, ON_Xform &xform) const
bool | GetTextXform (const ON_RECT gdi_text_rect, const ON_Font &font, const ON_DimStyle *dimstyle, double dimscale, const ON_Viewport *vp, const ON_Xform *model_xform, ON_Xform &text_xform) const
bool | GetTextXform (ON_RECT gdi_text_rect, const ON_Font &font, const ON_DimStyle &dimstyle, double dimscale, const ON_Viewport *vp, ON_Xform &xform) const
bool | GetTextPoint (ON_2dPoint &text_2d_point) const
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual void | Dump (ON_TextLog &) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Additional Inherited Members

Static Public Member Functions inherited from ON_Annotation2
static const wchar_t * | DefaultText ()
Public Attributes inherited from ON_Annotation2
ON::eAnnotationType | m_type
ON::eTextDisplayMode | m_textdisplaymode
ON_Plane | m_plane
ON_2dPointArray | m_points
ON_Annotation2Text | m_usertext
bool | m_userpositionedtext
bool | m_annotative_scale
int | m_index
double | m_textheight
unsigned int | m_justification

## Detailed Description

Definition at line 2017 of file opennurbs_annotation2.h.

## Member Enumeration Documentation

enum ON_Leader2::POINT_INDEX

Enumerator
arrow_pt_index |
text_pivot_pt |
tail_pt |

Definition at line 2048 of file opennurbs_annotation2.h.

## Constructor & Destructor Documentation

ON_Leader2::ON_Leader2 | ( |  | ) |

ON_Leader2::~ON_Leader2 | ( |  | ) |

## Member Function Documentation

void ON_Leader2::AddPoint | ( | const ON_2dPoint & | point | ) |

bool ON_Leader2::CreateFromV2 | ( | const ON_Annotation & | v2_ann,
|  | const ON_3dmAnnotationSettings & | settings,
|  | int | dimstyle_index
| ) |  |

ON_2dPoint ON_Leader2::Dim2dPoint | ( | int | point_index | ) | const

ON_3dPoint ON_Leader2::Dim3dPoint | ( | int | point_index | ) | const

bool ON_Leader2::GetArrowHeadDirection | ( | ON_2dVector & | arrowhead_dir | ) | const

bool ON_Leader2::GetArrowHeadTip | ( | ON_2dPoint & | arrowhead_tip | ) | const

ON_BOOL32 ON_Leader2::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = `false`
| ) |  | const

virtual

Implements ON_Geometry.

bool ON_Leader2::GetTextDirection | ( | ON_2dVector & | text_dir | ) | const

bool ON_Leader2::GetTightBoundingBox | ( | ON_BoundingBox & | tight_bbox,
|  | int | bGrowBox = `false`,
|  | const ON_Xform * | xform = `0`
| ) |  | const

virtual

Reimplemented from ON_Geometry.

void ON_Leader2::GetV2Form | ( | ON_Leader & | leader | ) |

ON_BOOL32 ON_Leader2::IsValid | ( | ON_TextLog * | text_log = `0` | ) | const

virtual

Reimplemented from ON_Annotation2.

ON_BOOL32 ON_Leader2::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Annotation2.

bool ON_Leader2::RemovePoint | ( | int | index = `-1` | ) |

ON_BOOL32 ON_Leader2::Transform | ( | const ON_Xform & | xform | ) |

virtual

Reimplemented from ON_Annotation2.

ON_BOOL32 ON_Leader2::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Annotation2.

The documentation for this class was generated from the following file:

- /build/pcl-0nnAvv/pcl-1.7.2/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_annotation2.h